<template>
  <div class="subscribe-view">
    <div class="header-form">
      <h1>Sablier</h1>
      <p>{{ status }}</p>
    </div>
    <div class="login-form">
      <form id="subForm" @submit.prevent="subscribe">
        <h2>Sign Up</h2>
        <label for="username">Email</label>
        <input type="text" v-model="email" name="email" />
        <label for="userpwd">Password</label>
        <input type="password" v-model="passwd" name="userpwd" />
        <input type="submit" class="login-button" value="Sign Up" />
      </form>
    </div>
  </div>
</template>

<script>
var axios = require("axios");
axios.defaults.withCredentials = true;

export default {
  name: "TemplateSubscribe",
  data: function() {
    return {
      email: null,
      passwd: null,
      status: null
    };
  },
  mounted: function() {
    if (this.$auth.isLoggedIn(this.$cookie)) {
      this.$auth.logOut(this.$cookie);
      this.$router.go();
    }
  },
  methods: {
    subscribe: function() {
      this.$caller.subscribe(this.email, this.passwd)
      .then(response => {
          if (response.data.error) this.status = response.data.error; 
          else this.$emit('signUpValidated', this.email); 
      })
      .catch(err =>  this.status = err);
    }
  }
};
</script>

<style>
.header-form {
  max-width: 400px;
  margin: auto;
  margin-top: 200px;
}

.login-form {
  border: 1px solid lightgray;
  border-radius: 10px;
  padding: 20px;
  flex-grow: 1;
  max-width: 400px;
  margin: auto;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  margin-top: 50px;
}

h1 {
  font-size: 58px;
  margin: 0;
}

h2 {
  font-size: 26px;
  margin: 0;
}

form {
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
}

.login-form > form > * {
  margin-bottom: 10px;
  width: 400px;
}

.login-form > form > input:not([type="checkbox"]) {
  /* Remove default style */
  -webkit-appearance: none;
  -moz-appearance: none;
  -ms-appearance: none;
  -o-appearance: none;
  appearance: none;
  border: 0px;
  border-bottom: 1px solid lightgray;
  font-size: 20px;
  line-height: 20px;
}

.login-button {
  height: 35px;
  border-radius: 10px;
  margin-top: 10px;
}
</style>